-- luacheck: globals app os verboseLevel connect
local app = app
local Class = require "Base.Class"
local Unit = require "Unit"
local GainBias = require "Unit.ViewControl.GainBias"
local ply = app.SECTION_PLY

local Pink = Class{}
Pink:include(Unit)

function Pink:init(args)
  args.title = "Pink Noise"
  args.mnemonic = "PN"
  Unit.init(self,args)
end

function Pink:onLoadGraph(channelCount)
  if channelCount==2 then
    self:loadStereoGraph()
  else
    self:loadMonoGraph()
  end
end

function Pink:loadMonoGraph()
  local noise1 = self:createObject("PinkNoise","noise1")
  connect(noise1,"Out",self,"Out1")
end

function Pink:loadStereoGraph()
  local noise1 = self:createObject("PinkNoise","noise1")
  local noise2 = self:createObject("PinkNoise","noise2")
  connect(noise1,"Out",self,"Out1")
  connect(noise2,"Out",self,"Out2")
end

return Pink
