-- luacheck: globals app os verboseLevel connect
local app = app
local Class = require "Base.Class"
local Unit = require "Unit"
local GainBias = require "Unit.ViewControl.GainBias"
local ply = app.SECTION_PLY

local White = Class{}
White:include(Unit)

function White:init(args)
  args.title = "White Noise"
  args.mnemonic = "WN"
  Unit.init(self,args)
end

function White:onLoadGraph(channelCount)
  if channelCount==2 then
    self:loadStereoGraph()
  else
    self:loadMonoGraph()
  end
end

function White:loadMonoGraph()
  local noise1 = self:createObject("WhiteNoise","noise1")
  connect(noise1,"Out",self,"Out1")
end

function White:loadStereoGraph()
  local noise1 = self:createObject("WhiteNoise","noise1")
  local noise2 = self:createObject("WhiteNoise","noise2")
  connect(noise1,"Out",self,"Out1")
  connect(noise2,"Out",self,"Out2")
end

return White
