-- luacheck: globals app os verboseLevel connect tie
local app = app
local Class = require "Base.Class"
local ClockBase = require "builtins.Timing.ClockBase"
local GainBias = require "Unit.ViewControl.GainBias"
local InputGate = require "Unit.ViewControl.InputGate"
local Encoder = require "Encoder"
local ply = app.SECTION_PLY

local ClockInBPM = Class{}
ClockInBPM:include(ClockBase)

function ClockInBPM:init(args)
  ClockBase.init(self,args)
end

function ClockInBPM:onLoadGraph(channelCount)
  local clock = self:createObject("ClockInBPM","clock")
  ClockBase.loadBaseGraph(self, channelCount, clock)
  local tempo = self:createObject("ParameterAdapter","tempo")
  tie(clock,"Tempo",tempo,"Out")
  self:createMonoBranch("tempo",tempo,"In",tempo,"Out")
end

local views = {
  expanded = {"sync","tempo","mult","div","width"},
  collapsed = {},
}

function ClockInBPM:onLoadViews(objects,branches)
  local controls = ClockBase.loadBaseView(self,objects,branches)

  controls.tempo = GainBias {
    button = "bpm",
    description = "Clock Tempo",
    branch = branches.tempo,
    gainbias = objects.tempo,
    range = objects.tempo,
    biasMap = Encoder.getMap("tempo"),
    biasUnits = app.unitNone,
    initialBias = 120
  }

  return controls, views
end

return ClockInBPM
